class IntroState

	def initialize
		super
		
		@actions = AS::Event::ActionListener.new
		@actions.action(AS::Event.source_for_key(:Key_ESCAPE)){|event|
			AS::GameState.stop unless event.state
		}
		
		@actions.action(AS::Event.source_for_key(:Key_SPACE)){|event| 
			AS::GameState::TickLimitedState.new(1.0/60.0, PlayState.new(Level1.new)).run unless event.state
		}
		
		@girlForklift = SimpleSprite.new(GirlForklift, 2)
		@boyForklift = SimpleSprite.new(BoyForklift)
		@heart = SimpleSprite.new(Heart)

		#flip horiz:
		@boyForklift.scale_x = -1

		@text = makeText

		@view_root = AS::Scene::GroupNode.new [
			@girlForklift,
			@boyForklift,
			@heart,
			@text
		]
		
		@girlForklift.pos = vec2(175-20,130-20)
		@boyForklift.pos = vec2(225-20+40,130-16)
		@heart.pos = vec2(200-4,145)

		@game_ticks = 0
		@timer = AS::TickTimer.new(FRAMERATE)
	end
	
	def makeText
		text = "Forklift Platformer"
		splash_text = AS::Scene::SpriteNode.new(AS::Scene::TextNode.new(Font, text))
		splash_text.scale = 0.85
		splash_text.pos = vec2(GameWidth / 2 - Font.string_width(text) * splash_text.scale / 2.0, 210)
		p splash_text.pos 
		p GameWidth
		p Font.string_width(text)
		p Font.string_width(text)/(2.0* splash_text.scale)
		
		text = "A heartwarming tale of love..."
		keys_text = AS::Scene::SpriteNode.new(AS::Scene::TextNode.new(Font, text))
		keys_text.scale = 0.6
		keys_text.pos = vec2(GameWidth / 2 - Font.string_width(text) * keys_text.scale / 2.0, 80)

		t1 = AS::Scene::BlendNode.new(nil, GL::SRC_ALPHA, GL::ONE_MINUS_SRC_ALPHA) do
  		 AS::Scene::GroupNode.new [
				 AS::Scene::ColorNode.new(@text_color_1 = AS::Color::Black.pack,splash_text), 
				 AS::Scene::ColorNode.new(@text_color_2 = AS::Color::Black.pack,keys_text)
  		 ]
    end

		return t1
	end
	
	def update
		@heart.pos = vec2(@heart.pos.x, 150 + ((5.0 * Math.sin(@game_ticks / 10.0)).to_i))
		
		#p @heart.pos.to_s #+ " and "+(5.0 * Math.sin(@game_ticks / 5.0)).to_s+" and ticks = " + @game_ticks.to_s
		@game_ticks += 1
		
		if(@game_ticks > 30)
		  @text_color_1.color = AS::Color::RGB.new(1.0, 1.0, 1.0, [1, (@game_ticks-30) / 240.0].min)
		end

		if(@game_ticks > 240)
		  @text_color_2.color = AS::Color::RGB.new(1.0, 1.0, 1.0, [1, (@game_ticks-240) / 240.0].min)
		end
		
	end
	
	def input(event)
		@actions.call(event)
	end

	def draw
		AS.clear_screen
		@view_root.render
	end
	
end

