
class Level1
	
	def add_game_object(obj)
		@space.add_body(obj.body)
		@space.add_shape(obj.shape)
	end
 
 	LEVEL_LENGTH = 5000
 
	def set_up_space(space)
		@space = space

		inf = 1.0/0.0
		static_body = CP::Body.new(inf, inf)
		
		seg = CP::Shape::Segment.new(static_body, vec2(10, 10), vec2(10, 300), 0)
		seg.u = 1.0
		seg.collision_type = :terrain
		@space.add_static_shape(seg)
		
		seg = CP::Shape::Segment.new(static_body, vec2(0, 300), vec2(LEVEL_LENGTH, 300), 0)
		seg.u = 0.0
		seg.collision_type = :terrain
		@space.add_static_shape(seg)
		
		seg = CP::Shape::Segment.new(static_body, vec2(10, 10), vec2(LEVEL_LENGTH, 10), 0)
		seg.u = 1.0
		seg.collision_type = :terrain
		@space.add_static_shape(seg)
		
=begin
		add_game_object(Barrel.new(70,70))
		add_game_object(Barrel.new(100,70))
		add_game_object(Barrel.new(100,80))
		add_game_object(Barrel.new(100,90))

		add_game_object(Crate.new(400,70))
		add_game_object(Crate.new(400,70))
		add_game_object(Crate.new(400,80))
		add_game_object(Crate.new(400,90))

		add_game_object(MCrate.new(600,70))
		add_game_object(MCrate.new(600,100))
		add_game_object(MCrate.new(600,130))
		add_game_object(MCrate.new(600,160))
		add_game_object(MCrate.new(600,190))
		add_game_object(MCrate.new(600,220))
		add_game_object(MCrate.new(600,250))
		add_game_object(MCrate.new(600,280))
=end
	end
	
end

# Author::    Scott Lembcke and Andy Korth
# Copyright:: Copyright (c) 2007 Howling Moon Software
#
class PlayState

	def initialize(level)
		p "starting playstate"
		@level = level
		
		@canvas = AS::Canvas.new(0,0, GameWidth, GameHeight)
		
		setup_actions()

		@player = ForkliftSprite.new
		@player.body.p = vec2(80, 80)
		
		@space = CP::Space.new
		@space.gravity = vec2(0, -200)
		@space.iterations = 15

   	@space.add_body(@player.body)
		@space.add_shape(@player.shape)

		@space.add_collision_func(:player, :terrain){
			|a, b| @player.airborne = false
			true #process collision
		}
		
		@level.set_up_space(@space)
		
		make_scenegraph
		
		@game_ticks = 0
		p "  ending init"
	end
	
	def ticks
		@game_ticks
	end
	
	def make_scenegraph
		@heart = SimpleSprite.new(Heart)
		@heart.pos = vec2(200,220)
	
		#The view root contains the scenegraph nodes for the hud
		@view_root = AS::Scene::GroupNode.new [
			@player,
			@heart
		]
	end
	
	def setup_actions()
		@input_pad = AS::Event::InputPad.new
		@input_pad.kaxis(:zoom, :Key_RIGHT, :Key_LEFT)

		@actions = AS::Event::ActionListener.new
		@actions.action(AS::Event.source_for_key(:Key_ESCAPE)){|event| AS::GameState.stop unless event.state}
		@actions.action(AS::Event.source_for_key(:Key_SPACE)){|event| @player.activate_jets unless event.state}

	end
	
	def click
		mx, my = *AS::Event.mouse_pos
		
	end
	
	def input(event)
		@actions.call(event)
		@input_pad.call(event)
	end
	
	def update
		#p "  update"

	
		@player.update(@input_pad)
		@space.step(FRAMERATE)
		
			#p "  end step"
		
		@game_ticks += 1
		
		@canvas.slew_pos(vec2(@player.body.p.x - (@canvas.w/ 2.0),0), 0.2)
		@canvas.set
		
		#p "end update"
	end
	
	def draw
			#p "draw"

	
		AS.clear_screen

		@view_root.render
		#@level.draw
		
		#puts 'drawing on tick ' + @game_ticks.to_s
		#AS.print_gl_errors
		#p "end draw"

	end
end
