class PreMultAlphaBlendNode < AS::Scene::BlendNode
	def initialize(child)
		super(nil, GL::ONE, GL::ONE_MINUS_SRC_ALPHA, child)
	end
end

class FancyTextNode < AS::Scene::ColorNode

  attr_reader :x, :y, :width, :height

	def initialize(xoffset, yoffset, font_scale, color, text, centered = true)
	
    @width = ThisFont.string_width(text)*font_scale
    @height = ThisFont.height*font_scale

 		@x = xoffset
		@y = yoffset
 		@x -= @width*0.5 if centered
 		@y -= @height*0.5 if centered
 		
		packed_color = AS::PackedColor.new(color)
		child = PreMultAlphaBlendNode.new{
			matrix = AS::Transform2D.translate(@x, @y)
			matrix *= AS::Transform2D.scale(font_scale, font_scale)
			packed_matrix = AS::PackedMatrix.new(matrix)
			AS::Scene::MatrixNode.new(GL::MODELVIEW, packed_matrix){
				AS::Scene::TextNode.new(ThisFont, text)
			}
		}

		super(packed_color, child)
	end
end

class MusicPlayer < AS::Music

	def play
		@isPlaying = true
		super
	end
	
	def toggle
		if @isPlaying
			pause
		else
			resume
		end
	end
end